=encoding utf8

=head1 NAME

Mail::Box::Parser::Perl - reading messages from file using Perl

=head1 INHERITANCE

 Mail::Box::Parser::Perl
   is a Mail::Box::Parser
   is a Mail::Reporter

=head1 SYNOPSIS

=head1 DESCRIPTION

The C<Mail::Box::Parser::Perl> implements parsing of messages
in Perl.  This may be a little slower than the C<C> based parser
L<Mail::Box::Parser::C|Mail::Box::Parser::C>, but will also work on platforms where no C
compiler is available.

Extends L<"DESCRIPTION" in Mail::Box::Parser|Mail::Box::Parser/"DESCRIPTION">.

=head1 METHODS

Extends L<"METHODS" in Mail::Box::Parser|Mail::Box::Parser/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Box::Parser|Mail::Box::Parser/"Constructors">.

=over 4

=item $class-E<gt>B<new>(%options)

Inherited, see L<Mail::Box::Parser/"METHODS">

 -Option           --Defined in       --Default
  file                                  undef
  filename                              <required>
  fix_header_errors  Mail::Box::Parser  false
  mode                                  'r'
  trusted            Mail::Box::Parser  false

=over 2

=item file => $filehandle

Any IO::File or C<GLOB> C<$filehandle> which can be used to read
the data from.  In case this option is specified, the C<filename> is
informational only.

=item filename => FILENAME

The name of the file to be read.

=item fix_header_errors => BOOLEAN

=item mode => $mode

File open C<$mode>, which defaults to C<'r'>, which means `read-only'.
See C<perldoc -f open> for possible modes.  Only applicable
when no C<file> is specified.

=item trusted => BOOLEAN

=back

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Box::Parser|Mail::Box::Parser/"Attributes">.

=over 4

=item $any-E<gt>B<defaultParserType>( [$class] )

Inherited, see L<Mail::Box::Parser/"Attributes">

=item $obj-E<gt>B<file>()

Z<>

=item $obj-E<gt>B<filename>()

Returns the name of the file this parser is working on.

=item $obj-E<gt>B<fixHeaderErrors>( [BOOLEAN] )

Inherited, see L<Mail::Box::Parser/"Attributes">

=item $obj-E<gt>B<openMode>()

Z<>

=item $obj-E<gt>B<trusted>()

Inherited, see L<Mail::Box::Parser/"Attributes">

=back

=head2 Parsing

Extends L<"Parsing" in Mail::Box::Parser|Mail::Box::Parser/"Parsing">.

=over 4

=item $obj-E<gt>B<bodyAsFile>( $fh [$chars, [$lines]] )

Inherited, see L<Mail::Box::Parser/"Parsing">

=item $obj-E<gt>B<bodyAsList>( [$chars, [$lines]] )

Inherited, see L<Mail::Box::Parser/"Parsing">

=item $obj-E<gt>B<bodyAsString>( [$chars, [$lines]] )

Inherited, see L<Mail::Box::Parser/"Parsing">

=item $obj-E<gt>B<bodyDelayed>( [$chars, [$lines]] )

Inherited, see L<Mail::Box::Parser/"Parsing">

=item $obj-E<gt>B<closeFile>()

Close the file which was being parsed.

=item $obj-E<gt>B<fileChanged>()

Returns whether the file which is parsed has changed after the last
time takeFileInfo() was called.

=item $obj-E<gt>B<filePosition>( [$position] )

Returns the location of the next byte to be used in the file which is
parsed.  When a C<$position> is specified, the location in the file is
moved to the indicated spot first.

=item $obj-E<gt>B<lineSeparator>()

Inherited, see L<Mail::Box::Parser/"Parsing">

=item $obj-E<gt>B<openFile>(%options)

[3.012] Open the file to be parsed.

=item $obj-E<gt>B<readHeader>()

Inherited, see L<Mail::Box::Parser/"Parsing">

=item $obj-E<gt>B<restart>(%options)

Restart the parser on a certain file, usually because the content has
changed.  The C<%options> are passed to L<openFile()|Mail::Box::Parser::Perl/"Parsing">.

=item $obj-E<gt>B<start>(%options)

Start the parser by opening a file.

 -Option--Default
  file    undef

=over 2

=item file => FILEHANDLE|undef

The file is already open, for instance because the data must be read
from STDIN.

=back

=item $obj-E<gt>B<stop>()

Stop the parser, which will include a close of the file.  The lock on the
folder will not be removed (is not the responsibility of the parser).
Improves base, see L<Mail::Box::Parser/"Parsing">

=item $obj-E<gt>B<takeFileInfo>()

Capture some data about the file being parsed, to be compared later.

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Box::Parser|Mail::Box::Parser/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Box::Parser|Mail::Box::Parser/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head1 DIAGNOSTICS

=over 4

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=item Error: filename or handle required to create a parser.

Cast by C<new()>

=item Error: parser $type does not extend $pkg.

Cast by C<defaultParserType()>

=item Warning: unexpected end of header in $file:\n $line

Cast by C<readHeader()>

=back

=head1 SEE ALSO

This module is part of Mail-Message version 4.03,
built on January 26, 2026. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

